// $Id: EOFault.h,v 1.3 2004/01/07 05:10:31 helge Exp $

#ifndef __EOFault_h__
#define __EOFault_h__

#import <Foundation/NSObject.h>

@class NSArray, NSDictionary, NSString, NSMethodSignature;

@class EOFaultHandler;

@interface EOFault
{
  Class          isa;
  EOFaultHandler *faultResolver;
}

+ (void)makeObjectIntoFault:(id)_object withHandler:(EOFaultHandler *)_handler;
+ (EOFaultHandler *)handlerForFault:(id)_fault;

/* Inquire about a fault */

+ (BOOL)isFault:(id)object;
+ (BOOL)isFault;
- (BOOL)isFault;
+ (void)clearFault:(id)fault;

+ (Class)targetClassForFault:fault;

/* Non-Faulting Instance methods */

- (Class)superclass;
- (Class)class;
+ (Class)class;
- (BOOL)isKindOfClass:(Class)aClass;
- (BOOL)isMemberOfClass:(Class)aClass;
- (BOOL)conformsToProtocol:(Protocol *)aProtocol;
- (BOOL)respondsToSelector:(SEL)aSelector;

+ (id)self;

- (void)dealloc;
- retain;
- (void)release;
- autorelease;
- (unsigned)retainCount;
- (NSZone*)zone;

- (BOOL)isProxy;
- (BOOL)isGarbageCollectable;
- (NSString *)description;

- (NSMethodSignature *)methodSignatureForSelector:(SEL)_selector;

@end /* EOFault */

#include <GDLAccess/EOFaultHandler.h>

#endif  /* __EOFault_h__ */
